import 'package:fis_measure/interfaces/process/calculators/values.dart';
import 'package:fis_measure/process/calcuators/formulas/index.dart' as formulas;

import 'package:vid/us/vid_us_unit.dart';

import '../interfaces/general.dart';
import 'utils.dart';

class GeneralFormulasBase implements IGeneralFormulas {
  @override
  UnitFloatValue svDiam(UnitFloatValue diam, UnitFloatValue vti) {
    final value = formulas.GeneralFormulas.svDiam(
      diam.convert(VidUsUnit.cm),
      vti.convert(VidUsUnit.cm),
    );
    return UnitFloatValue(value, VidUsUnit.cm3);
  }

  @override
  UnitFloatValue csa(UnitFloatValue diam) {
    final value = formulas.GeneralFormulas.csa(
      diam.convert(VidUsUnit.cm),
    );
    return UnitFloatValue(value, VidUsUnit.cm2);
  }
}
