import 'package:fis_measure/interfaces/process/calculators/values.dart';

abstract class ICardiacFormulas {
  UnitFloatValue edvTech(UnitFloatValue lvidd);
  UnitFloatValue esvTech(UnitFloatValue lvids);
  UnitFloatValue edvCube(UnitFloatValue lvidd);
  UnitFloatValue esvCube(UnitFloatValue lvids);
  UnitFloatValue ef(UnitFloatValue edv, UnitFloatValue esv);

  UnitFloatValue lvdMass(
      UnitFloatValue ivsd, UnitFloatValue lvidd, UnitFloatValue lvpwd);
  UnitFloatValue lvdMassAL(UnitFloatValue lvadSaxEpi,
      UnitFloatValue lvadSaxEndo, UnitFloatValue lvldApical);
  UnitFloatValue lvdMassIndex(UnitFloatValue lvdmass, {required double bsa});
  UnitFloatValue fsPercent(UnitFloatValue lvidd, UnitFloatValue lvids);
  UnitFloatValue ivsPercent(UnitFloatValue ivss, UnitFloatValue ivsd);
  UnitFloatValue lvpwPercent(UnitFloatValue lvpws, UnitFloatValue lvpwd);
  UnitFloatValue sv(UnitFloatValue edv, UnitFloatValue esv);
  UnitFloatValue co(UnitFloatValue sv, {required int hr});
  UnitFloatValue ci(UnitFloatValue sv, {required int hr, required double bsa});
  UnitFloatValue si(UnitFloatValue sv, {required double bsa});
  UnitFloatValue lvevi(UnitFloatValue lvev, {required double bsa});
  UnitFloatValue lvidIndex(UnitFloatValue lvid, {required double bsa});
  UnitFloatValue lvidN(UnitFloatValue lvid, UnitFloatValue weight);
}
