import 'dart:ui';

import 'package:fis_common/logger/logger.dart';
import 'package:fis_jsonrpc/rpc.dart';
import 'package:fis_measure/process/primitives/urm_measure/urm_ellipse_measure.dart';

// import 'package:fis_measure/process/primitives/urm_straightline.dart';
import 'package:fis_measure/process/workspace/urm/application.dart';

import '../calculator.dart';

class URMEllipseMeasureCal extends Calculator<URMEllipseMeasure, double> {
  URMEllipseMeasureCal(
    URMEllipseMeasure ref,
  ) : super(ref);
  URMSimpleMeasureParams? param;
  @override
  void calculate() {}

  /// 处理获取到的URM参数
  void handleURMSimpleMeasureParams() {
    if (ref.feature == null) return;
    Size urmResultSize = const Size(0, 0);

    try {
      if (ref.application is! URMApplication) {
        return;
      }
      final URMApplication urmApplication = ref.application as URMApplication;
      urmResultSize = Size(urmApplication.resultWidth.toDouble(),
          urmApplication.resultHeight.toDouble());

      // 添加入参
      List<UrmPoint> srcDPoints = [];
      // if (ref.feature is! EllipseFeature) {
      //   srcDPoints = [];
      // }
      for (var point in ref.feature!.innerPoints) {
        srcDPoints.add(urmApplication.localToView(point));
      }
      param = URMSimpleMeasureParams(
        urmMeasureType: URMMeasureType.URMCurvature,
        rOIType: URMROIType.URMEllipse,
        srcDPoints: srcDPoints,
      );
    } catch (e) {
      logger.e('URM handleURMSimpleMeasureParams error: $e');
    }
  }
}
