import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

class SingleIconButton extends StatelessWidget {
  const SingleIconButton(
      {Key? key, required this.icon, required this.onPressed})
      : super(key: key);
  final IconData icon;
  final VoidCallback onPressed;
  @override
  Widget build(BuildContext context) {
    return IconButton(
      splashRadius: 2,
      padding: EdgeInsets.zero,
      onPressed: () {
        HapticFeedback.lightImpact();
        onPressed();
      },
      icon: Icon(
        icon,
        color: Colors.white,
      ),
    );
  }
}
